import { SFCDescriptor } from '@vue/compiler-sfc';
import * as t from '@babel/types';
import { ParseResult } from '@babel/parser';
export declare const newLine = "REPLACE_FOR_NEW_LINE";
export declare const parseVueFromContent: (content: string) => SFCDescriptor;
export declare const wrapNewLineComment: (node: t.VariableDeclaration | t.ExpressionStatement | t.Statement | t.BlockStatement) => t.Statement;
export declare const beforeValidate: (desc: SFCDescriptor) => {
    isOk: boolean;
    content: string;
    errors: string[];
};
export declare const checkHasClassComponent: (ast: ParseResult<t.File>) => {
    isOk: boolean;
    content: string;
    errors: string[];
};
